﻿<Page
    xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
    xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
    xmlns:local="using:DevicesManagement.Views"
    xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
    xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
    xmlns:converters ="using:DevicesManagement.Services"
    xmlns:VM="using:DevicesManagement.ViewModels"
    xmlns:Custom="using:Microsoft.UI.Xaml.Controls"
    x:Class="DevicesManagement.Views.DevicesPage"
    mc:Ignorable="d">
    <Page.Resources>

    </Page.Resources>
    <Page.Background>
        <ThemeResource ResourceKey="ApplicationPageBackgroundThemeBrush"/>
    </Page.Background>
    <Page.DataContext>
        <VM:DevicesViewModel x:Name="devicesViewModel"/>
    </Page.DataContext>
    <Grid>
        <Grid.RowDefinitions>
            <RowDefinition Height="auto"/>
            <RowDefinition/>
            <RowDefinition Height="auto"/>
        </Grid.RowDefinitions>
        <CommandBar Grid.Row="0">

            <CommandBar.Content>
                <TextBlock Text="Devices Management" Margin="12,14"/>
            </CommandBar.Content>
            <AppBarSeparator/>
            <AppBarButton Icon="Add" Label="Add Device" Command="{Binding btnOpenAdd_Clicked}"/>
            <AppBarButton Icon="Edit" Label="Edit" Command="{Binding btnOpenUpdate_Clicked}"/>
            <AppBarButton Icon="Delete" Label="Delete" Command="{Binding btnDelete_Clicked}"/>
            <AppBarButton Icon="Refresh" Label="Refresh" Command="{Binding btnRefresh_Clicked}" />
            <AppBarButton Icon="Forward" Label="Sign Out"/>

        </CommandBar>
        <ScrollViewer Grid.Row="1" Margin="12" HorizontalScrollMode="Disabled" VerticalContentAlignment="Stretch">
            <StackPanel >
                <StackPanel.ChildrenTransitions>
                    <TransitionCollection>
                        <EntranceThemeTransition IsStaggeringEnabled="True" />
                    </TransitionCollection>
                </StackPanel.ChildrenTransitions>

                <Border  BorderThickness="1" BorderBrush="#f1f1f1" Margin="0 12 0 12">
                    <Grid>
                        <Grid.ColumnDefinitions>
                            <ColumnDefinition/>
                            <ColumnDefinition/>
                            <ColumnDefinition/>
                            <ColumnDefinition/>
                            <ColumnDefinition/>
                            <ColumnDefinition/>
                        </Grid.ColumnDefinitions>
                        <TextBlock Grid.Column="0" Text="Device Id" HorizontalAlignment="Center" FontWeight="Bold"/>
                        <TextBlock Grid.Column="1" Text="Device Name" HorizontalAlignment="Center" FontWeight="Bold"/>
                        <TextBlock Grid.Column="2" Text="Status" HorizontalAlignment="Center" FontWeight="Bold"/>
                        <TextBlock Grid.Column="3" Text="Type Id" HorizontalAlignment="Center" FontWeight="Bold"/>
                        <TextBlock Grid.Column="4" Text="Image" HorizontalAlignment="Center" FontWeight="Bold"/>
                        <CheckBox Grid.Column="5" IsChecked="{Binding AllChecked, Mode=TwoWay}" HorizontalAlignment="Center" VerticalAlignment="Top" />
                    </Grid>
                </Border>
                <ItemsControl ItemsSource="{x:Bind Mode=OneWay, Path=devicesViewModel.Devices}">
                    <ItemsControl.ItemTemplate>
                        <DataTemplate x:DataType="VM:DeviceViewModel">
                            <Border BorderThickness="1" BorderBrush="#f1f1f1">
                                <Grid>
                                    <Grid.ColumnDefinitions>
                                        <ColumnDefinition/>
                                        <ColumnDefinition/>
                                        <ColumnDefinition/>
                                        <ColumnDefinition/>
                                        <ColumnDefinition/>
                                        <ColumnDefinition/>
                                    </Grid.ColumnDefinitions>
                                    <Border Grid.Column="0" BorderThickness="1 0 1 0" BorderBrush="#f1f1f1" >
                                        <TextBlock Margin="10 0 0 0" Text="{x:Bind FallbackValue='', Mode=OneWay, Path=DeviceId}" HorizontalAlignment="Center" VerticalAlignment="Center"/>
                                    </Border>
                                    <Border Grid.Column="1" BorderThickness="1 0 1 0" BorderBrush="#f1f1f1" >
                                        <TextBlock Text="{x:Bind FallbackValue='', Mode=OneWay, Path=DeviceName}" VerticalAlignment="Center" HorizontalAlignment="Center"/>
                                    </Border>
                                    <Border Grid.Column="2" BorderThickness="1 0 1 0" BorderBrush="#f1f1f1" >
                                        <TextBlock Text="{x:Bind FallbackValue='', Mode=OneWay, Path=Status}" VerticalAlignment="Center" HorizontalAlignment="Center"/>
                                    </Border>
                                    <Border Grid.Column="3" BorderThickness="1 0 1 0" BorderBrush="#f1f1f1" >
                                        <TextBlock Text="{x:Bind FallbackValue='', Mode=OneWay, Path=Type.devicetype_name}" VerticalAlignment="Center" HorizontalAlignment="Center"/>
                                    </Border>
                                    <Border Grid.Column="4" BorderThickness="1 0 1 0" BorderBrush="#f1f1f1" >
                                        <Image Height="50"  Source="{x:Bind FallbackValue='', Mode=OneWay, Path=Image}" VerticalAlignment="Center" HorizontalAlignment="Center"/>
                                    </Border>
                                    <Border Grid.Column="5" BorderThickness="1 0 1 0" BorderBrush="#f1f1f1" >
                                        <CheckBox IsChecked="{Binding IsChecked, FallbackValue=false, Mode=TwoWay}" VerticalAlignment="Center" HorizontalAlignment="Center" />
                                    </Border>
                                </Grid>
                            </Border>
                        </DataTemplate>
                    </ItemsControl.ItemTemplate>
                </ItemsControl>
            </StackPanel>
        </ScrollViewer>
        <Grid Grid.Row="2" x:Name="pnDevice" VerticalAlignment="Stretch" Visibility="{Binding IsEnabledAddPanel, Mode=TwoWay}" Height="120">
            <Grid.Transitions>
                <TransitionCollection>
                    <EdgeUIThemeTransition Edge="Top"/>
                </TransitionCollection>
            </Grid.Transitions>
            <Grid.Background>
                <AcrylicBrush TintColor="#E6E6E6"/>
            </Grid.Background>
            <Grid.ColumnDefinitions>
                <ColumnDefinition Width="*"/>
                <ColumnDefinition Width="*"/>
                <ColumnDefinition Width="*"/>
                <ColumnDefinition Width="*"/>
                <ColumnDefinition Width="*"/>
            </Grid.ColumnDefinitions>
            <StackPanel Padding="10" Grid.Column="0">
                <TextBlock Text="Type Devices" TextWrapping="Wrap" VerticalAlignment="Top" />
                <ComboBox SelectedItem="{Binding AddPanelDevice.Type, Mode=TwoWay}" ItemsSource="{Binding DeviceTypes, Mode=TwoWay}" HorizontalAlignment="Stretch" SelectedIndex="0">
                    <ComboBox.ItemTemplate>
                        <DataTemplate x:DataType="VM:DeviceTypeViewModel">
                            <TextBlock Text="{Binding TypeName, Mode=OneWay}"/>
                        </DataTemplate>
                    </ComboBox.ItemTemplate>
                </ComboBox>
            </StackPanel>
            <StackPanel Padding="10" Grid.Column="1">
                <TextBlock  Text="Name Device"/>
                <TextBox PlaceholderText="Enter device name.." Text="{Binding AddPanelDevice.DeviceName, Mode=TwoWay}"/>
            </StackPanel>
            <Grid Padding="10" Grid.Column="2">
                <Grid.ColumnDefinitions>
                    <ColumnDefinition></ColumnDefinition>
                    <ColumnDefinition></ColumnDefinition>
                </Grid.ColumnDefinitions>
                <Button Grid.Column="0" Command="{Binding btnUploadImage_Clicked}"  VerticalAlignment="Stretch" HorizontalAlignment="Stretch">
                    <Button.Content>
                        <TextBlock Text="Choose Image" TextWrapping="WrapWholeWords" TextAlignment="Center"></TextBlock>
                    </Button.Content>
                </Button>
                <TextBlock Grid.Column="1" TextAlignment="Center" Text="{Binding AddPanelDevice.ImageName, Mode=OneWay}" TextWrapping="Wrap" VerticalAlignment="Center" HorizontalAlignment="Center"/>
            </Grid>
            <Grid Padding="10" Grid.Column="3">
                <Image Source="{Binding AddPanelDevice.Image, Mode=OneWay}" Stretch="Uniform"/>
            </Grid>
            <Grid Padding="10" Grid.Column="4">
                <Grid.RowDefinitions>
                    <RowDefinition></RowDefinition>
                    <RowDefinition></RowDefinition>
                </Grid.RowDefinitions>
                <Button Margin="5" Grid.Row="0" Content="Add" VerticalAlignment="Stretch" HorizontalAlignment="Stretch" Command="{Binding btnAdd_Clicked}"/>
                <Button Margin="5" Grid.Row="1" Content="Cancel" VerticalAlignment="Stretch" HorizontalAlignment="Stretch" Command="{Binding btnCancel_Clicked}"/>
            </Grid>
        </Grid>
        <Grid Grid.Row="2" VerticalAlignment="Stretch" Visibility="{Binding IsEnabledUpdatePanel, Mode=TwoWay}" Height="120">
            <Grid.Transitions>
                <TransitionCollection>
                    <NavigationThemeTransition />
                </TransitionCollection>
            </Grid.Transitions>
            <Grid.Background>
                <AcrylicBrush TintColor="#E6E6E6"/>
            </Grid.Background>
            <Grid.ColumnDefinitions>
                <ColumnDefinition Width="*"/>
                <ColumnDefinition Width="*"/>
                <ColumnDefinition Width="*"/>
                <ColumnDefinition Width="*"/>
                <ColumnDefinition Width="*"/>
            </Grid.ColumnDefinitions>
            <StackPanel Padding="10" Grid.Column="0">
                <TextBlock Text="Type Devices" TextWrapping="Wrap" VerticalAlignment="Top" />
                <ComboBox SelectedItem="{Binding AddPanelDevice.Type, Mode=TwoWay}" ItemsSource="{Binding DeviceTypes, Mode=TwoWay}" HorizontalAlignment="Stretch" SelectedIndex="0">
                    <ComboBox.ItemTemplate>
                        <DataTemplate x:DataType="VM:DeviceTypeViewModel">
                            <TextBlock Text="{Binding TypeName, Mode=OneWay}"/>
                        </DataTemplate>
                    </ComboBox.ItemTemplate>
                </ComboBox>
            </StackPanel>
            <StackPanel Padding="10" Grid.Column="1">
                <TextBlock  Text="Name Device"/>
                <TextBox PlaceholderText="Enter device name.." Text="{Binding AddPanelDevice.DeviceName, Mode=TwoWay}"/>
            </StackPanel>
            <Grid Padding="10" Grid.Column="2">
                <Grid.ColumnDefinitions>
                    <ColumnDefinition></ColumnDefinition>
                    <ColumnDefinition></ColumnDefinition>
                </Grid.ColumnDefinitions>
                <Button Grid.Column="0" Command="{Binding btnUploadImage_Clicked}"  VerticalAlignment="Stretch" HorizontalAlignment="Stretch">
                    <Button.Content>
                        <TextBlock Text="Choose Image" TextWrapping="WrapWholeWords" TextAlignment="Center"></TextBlock>
                    </Button.Content>
                </Button>
                <TextBlock Grid.Column="1" x:Name="imagePath" TextAlignment="Center" Text="{Binding AddPanelDevice.ImageName, Mode=OneWay}" TextWrapping="Wrap" VerticalAlignment="Center" HorizontalAlignment="Center"/>
            </Grid>
            <Grid Padding="10" Grid.Column="3">
                <Image x:Name="uploadedImage" Source="{Binding AddPanelDevice.Image, Mode=OneWay}" Stretch="Uniform"/>
            </Grid>
            <Grid Padding="10" Grid.Column="4">
                <Grid.RowDefinitions>
                    <RowDefinition></RowDefinition>
                    <RowDefinition></RowDefinition>
                </Grid.RowDefinitions>
                <Button Margin="5" Grid.Row="0" Content="Update" VerticalAlignment="Stretch" HorizontalAlignment="Stretch" Command="{Binding btnUpdate_Clicked}"/>
                <Button Margin="5" Grid.Row="1" Content="Cancel" VerticalAlignment="Stretch" HorizontalAlignment="Stretch" Command="{Binding btnCancel_Clicked}"/>
            </Grid>
        </Grid>
    </Grid>
</Page>
